import numpy as np
from types import FunctionType

def find_first_index_where(arr:np.ndarray, test:FunctionType) -> int:
    return _find_index_where(arr, test, False)

def find_last_index_where(arr:np.ndarray, test:FunctionType) -> int:
    return _find_index_where(arr, test, True)

def _find_index_where(arr:np.ndarray, test:FunctionType, rsearch:bool) -> int:
    searchRange = range(len(arr))
    if rsearch:
        searchRange = reversed(searchRange)

    for i in searchRange:
        if test(arr[i]):
            return i
    return -1

